#version 300 es
precision mediump float;
in vec2 vUv;

uniform sampler2D uTex;
uniform float in_blurOffset[14];
uniform float in_blurWeight[7];
uniform float in_imageWidth;
uniform float scale_offset;
uniform float in_imageHeight;
uniform int sampleCount;

out vec4 oFragColor;

void main() {
    vec2 xy = gl_FragCoord.xy;

    vec4 color     = vec4(0);
    vec2 wh       = vec2(in_imageWidth, in_imageHeight);
    for(int i=0; i < sampleCount; i++){
        vec2 offset   = vec2(in_blurOffset[i], in_blurOffset[i + sampleCount]);
        vec2 coord    = wh - abs(xy + offset - wh);
        vec4 color1    = texture(uTex,(coord)/wh + vec2(0, scale_offset));
        coord           = abs(xy - offset);
        vec4 color2    = texture(uTex,(coord)/wh + vec2(0, scale_offset));
        float weight    = in_blurWeight[i];
        color           += (color1 + color2) * weight;
    }
    color.a             = 1.0;
    oFragColor = color;
    //oFragColor = texture(uTex,vUv);
}