#version 300 es
uniform mat4 uMatrix;
uniform vec2 uOffset;

in vec3 aPosition;
in vec2 aUv;

out vec2 vUv;
out vec2 vPosition;
out float vLandMode;
uniform bool uRowLoop;

void main() {
    vUv = vec2(aUv.x, 1. - aUv.y);
    vec4 p = uMatrix * vec4(aPosition, 1.0);
    vUv.x *= (uRowLoop) ? 4.0 : 1.0;
    p /= p.w;
    vPosition = p.xy;
    vLandMode = step(uOffset.x + uOffset.y, 0.1);
    gl_Position = p;
}
