#version 300 es

precision highp float;

#define PI 3.14159265

// in vec2 texCoord;
in vec2 vUv;
out vec4 o_FragColor;

uniform vec3 SunDirection;

uniform vec3 FrustumA;
uniform vec3 FrustumC;
uniform sampler2D SkyView;
uniform sampler2D Noise;

float getRandomLite(float value, float seed) {
    float r = texture(Noise, vec2(seed, value)).r;
    return r;
}

vec2 texCoord2uv(vec2 texCoord)
{
    texCoord.y = 1. - texCoord.y;
    vec3 dir = normalize(mix(FrustumA, FrustumC, texCoord.y));
    // 计算俯仰角
    float theta = asin(dir.y);
    // 将俯仰角转换为纹理坐标的v分量  这个转换会在地平线附近压缩更多的纹理像素
    float v = 0.5 + 0.5 * sign(theta) * sqrt(abs(theta) / (PI / 2.));
    return vec2(SunDirection.y, (v * 256.0 - 115.0) / 141.0 + getRandomLite(texCoord.x, texCoord.y) * 0.005);
}

void main()
{
    vec2 texCoord = vUv;
    vec2 uv = texCoord2uv(texCoord);
    vec3 skyColor = texture(SkyView, uv).rgb;
    o_FragColor = vec4(skyColor, 1.);
}
