#version 300 es
precision highp float;
in vec2 vUv;
out vec4 fragColor;

uniform vec2 uResolution;
uniform float uOpacity;
uniform float uAlpha;
uniform float uTime;
uniform float uHeaviness;
//uniform float uFilter;
//uniform sampler2D uNoiseTex;

/* 去除随机 */
vec4 weatherEffect(vec2 uv) {

    float LAYERS = mix(10., 20., uHeaviness);
    float DEPTH = mix(0.8, 0.4, uHeaviness);
    float WIDTH = mix(0.2, 0.6, uHeaviness);
    float SPEED = mix(0.6, 1.5, uHeaviness);

    uv.y *= uResolution.y / uResolution.x;

    // 设置时间，加100为了避免时间倒流
    float time = uTime + 100.;

    const mat3 p = mat3(13.323122,23.5112,21.71123,21.1212,28.7312,11.9312,21.8112,14.7212,61.3934);
    // vec2 uv = vec2(1.,uResolution.y/uResolution.x)*fragCoord.xy / uResolution.xy;
    vec3 acc = vec3(0.0);
    float dof = 5.*sin(time*.1);
    for (int i=0;i<int(LAYERS);i++) {

        // if(uFilter >= 0.) {
        //     if(float(i) > abs(uFilter)) continue;
        // } else {
        //     if(float(i) <= abs(uFilter)) continue;
        // }

        float fi = float(i);
        vec2 q = uv*(1.+fi*DEPTH);
        q += vec2(q.y*(WIDTH*mod(fi*7.238917,1.)-WIDTH*.5),SPEED*time/(1.+fi*DEPTH*.03));
        vec3 n = vec3(floor(q),31.189+fi);
        // vec3 m = floor(n)*.00001 + fract(n);
        vec3 m = floor(n)*.001 + fract(n);
        vec3 mp = (31415.9+m)/fract(p*m);
        vec3 r = fract(mp);
        vec2 s = abs(mod(q,1.)-.5+.9*r.xy-.45);
        s += .01*abs(2.*fract(10.*q.yx)-1.);
        float d = .6*max(s.x-s.y,s.x+s.y)+max(s.x,s.y)-.01;
        float edge = .005+.05*min(.5*abs(fi-5.-dof),1.);
        acc += vec3(smoothstep(edge,-edge,d)*(r.x/(1.+.02*fi*DEPTH)));
    }
    // fragColor = vec4(vec3(acc),1.0);

    return vec4(1., 1., 1., acc * uAlpha);
}

void main() {
    vec2 uv = vUv;
    vec4 col = weatherEffect(uv);
    col.a *= uOpacity;
    fragColor = col;
}
